<%
'*******************************************
'CORE GENERAL
'PARTICULARLY INTENDED FOR DB-LESS FLASH CHAT SYSTEM
'Gus Mueller, April 2002
'*******************************************

'*******************************************
'setup global variables
'*******************************************

dim strUserData, UserID

'strUserData is double-delimited, with user data rows separated by -
'and fields separated by |, in the form userid|password|alias|isSuperuser
'note that in this example, there are only two users
strUserData="3|poo|gus|1-7|poo|bathtubgirl|0"

'UserID is stored in a cookie called xxunk in this application
UserID= request.cookies("xxunk")

'I also use one global Application variable to hold the server name - you might want to include the setting of this in Global.asa:

application("serverappend")="http://" & request.servervariables("HTTP_HOST")

'*******************************************
'user-related functions 
'these can easily be refitted for use in a database-
'based authentication system
'*******************************************
function AliasToUserID(byval strAlias)
	'looks up an alias for a userid
	dim intOut
	intOut=Data(strAlias, 2, 0, strUserData)
	AliasToUserID=myint(intOut)
end function

function UserIDToAlias(UserID)
	'looks up an alias for a userid
    dim strAlias
	strAlias="#"
	if UserID<>"" then
		strAlias=Data(strAlias, 0, 2, strUserData)
	end if
	UserIDToAlias=strAlias
end function

function AliastoPassword(strAlias)
	'looks up password for an alias
    dim strPassword
	strPassword=Data(strAlias, 2, 1, strUserData)
	AliastoPassword=strPassword
end function

'*******************************************
'string utilities
'*******************************************

function DeMultiple(byval strIn, byval strCharIn)
	'gets rid of repeated instances of strCharIn in strIn
	if strIn<>"" then
		DeMultiple=strIn 
		do while instr(DeMultiple, strCharIn & strCharIn) 
			DeMultiple=replace(DeMultiple, strCharIn & strCharIn, strCharIn)
		loop
	else
		DeMultiple=""
	end if
end Function

function StripEndQuotes(byval strIn)
'quotes around strIn are nuked
	if strIn<>"" then 
		if left(strIn,1)=chr(34) then
			strIn=right(strIn, len(strIn)-1)
		end if
		if right(strIn,1)=chr(34) then
			strIn=left(strIn, len(strIn)-1)
		end if
		strIn=replace(strIn, "%", "")
	end if
	StripEndQuotes=strIn
end function

function trimtosize(strIn, intSize)
	'cuts strIn at intSize
	if len(strIn)>intSize then
		strIn=left(strIn, intSize) & "..."
	end if
	trimtosize=strIn
end function

function pluralize(byval strIn, intNum)
	'handles pluralization
	dim charLast, strPos
	if strIn<>"" then
		if left(intNum, 3)="sta" then
			pluralize=""
		else
			charLast=right(strIn, 1)
			if charLast="s" or charLast="z" or charLast="x"  then
				strPos="es"
			else
				strPos="s"
			end if
			if isnumeric(intNum) then
				if intNum=1 then
					pluralize=strIn 
				else
					pluralize=strIn & strPos
				end if
			else
				pluralize=strIn 
			end if
		end if
	end if
end function

function JustDate(byval strIn)
	strIn=cstr(strIn)
	if instr(strIn, " ")>0 then
		strIn=split(strIn, " ")(0)
	end if
	if isdate(strIn) then
		strIn=cdate(strIn)
	else
		strIn=""
	end if
	JustDate=strIn
end function

function nukeseconds(byval strIn)
	'gets rid of seconds from a date
	dim intNukePlace, strAMPM
	if strIn<>"" then
		if left(strIn, 3)="sta" then
			nukeseconds=strIn
		else
			strAMPM=right(strIn, 2)
			intNukePlace=instrrev(strIn, ":")
			if intNukePlace>0 then
				nukeseconds=left(strIn, intNukePlace-1)
			else
				nukeseconds=strIn
			end if
			nukeseconds= nukeseconds & " " & strAMPM
		end if
	end if
end function

function doublequote(strIn)
	'quotes single quotes before passing them in to SQL
	doublequote=replace(strIn, "'", "''")
end function

'*******************************************
'formatting functions
'*******************************************

function TableWrap(strIn, strType, strClass)
	'wraps a text string with a table of various kinds
	dim strOut, strAlign, strColor, strSize
		strSize="500"
		if strType="offcolor" then 
			strAlign=""
			strColor="bgcolor=""" & subtlecolor(colBg) & chr(34)
		else
			strAlign="align=" & strType
			strColor=""
		end if
		if strSize="" then
		else
			strSize="size=" & strSize
		end if
		if strIn<>"" then
			strOut=strOut & tabit(2)  & "<table width=100% " & strAlign & ">" & vbNewLine
			strOut=strOut & tabit(3)  & "<tr>" & vbNewLine
			strOut=strOut & tabit(4) & "<td " & strColor & ">" & vbNewLine
			strOut=strOut & tabit(5) & "<span  class=""" & strClass & """>" & vbNewLine
			strOut=strOut & tabit(5) & strIn & vbNewLine
			strOut=strOut & tabit(5) & "</span>" & vbNewLine
			strOut=strOut & tabit(4)  & "</td>" & vbNewLine
			strOut=strOut & tabit(3)  & "</tr>" & vbNewLine
			strOut=strOut & tabit(2)  & "</table>" & vbNewLine
		end if
	TableWrap=strOut
end function

function LabelBar(colMedium, strClass, strLabel)
	'makes a colorful labeled bar, with the background color of colMedium and  
	'the label saying strLabel in the color of colBG
	dim strOut
	strOut=strOut & "<table bgcolor=" & colMedium & " width=100% >" & vbNewLine
	strOut=strOut & vbTab & "<td>" & vbNewLine
	strOut=strOut & tabit(2)& "&nbsp;&nbsp;<b><span class=""" & strClass & """>" & strLabel & vbNewLine
	strOut=strOut & tabit(2)& "</span>" & vbNewLine
	strOut=strOut & vbTab & "</td>" & vbNewLine
	strOut=strOut & "</table>" & vbNewLine
	LabelBar=strOut
end function

function tabit(intIn)
	'generates a string of intIn tabs
	dim t, strOut
	for t=0 to intIn
		strOut=strOut & vbTab
	next
	tabit=strOut
end function

function BodyWrap(strIn, strTitle, colBG, colText, colLink, strOnLoad)
	dim strOut
	strOut="<html>" & vbNewLine
	strOut=strOut & " <head>" & vbNewLine
	strOut=strOut & "  <title>" & strTitle & "</title>" & vbNewLine
	strOut=strOut & "  <script src=""/global/main.js""></script>" & vbNewLine
	strOut=strOut & "<link rel=""stylesheet"" href=""/global/css.css"">" & vbNewLine
	strOut=strOut & "  </head>" & vbNewLine
	strOut=strOut & " <body marginheight=0 topmargin=3 leftmargin=3 marginwidth=0 bgcolor=""" & colBG & """ text=""" & colText & """ vlink=""" & colLink & """ link=""" & colLink & """ " & strOnLoad & ">" & vbNewLine
	strOut = strOut & strIn
	strOut=strOut & " </body>" & vbNewLine
	strOut=strOut & "</html>" & vbNewLine
	BodyWrap=strOut
end function

function traytable(strTopContent, strLeftContent, strRightContent, intSize)
	dim strOut
	strOut=strOut & "<table cellspacing=""0""   cellpadding=""0"" border=""0"">" & vbNewLine
	strOut=strOut & "<tr>" & vbNewLine
	strOut=strOut & "<td colspan=2 valign=top >" & vbNewLine
	strOut=strOut & strTopContent & vbNewLine
	strOut=strOut & "</td>" & vbNewLine
	strOut=strOut & "</tr>" & vbNewLine
	strOut=strOut & "<tr>" & vbNewLine
	strOut=strOut & "<td valign=top width=" & intSize & ">" & vbNewLine
	strOut=strOut & strLeftContent & vbNewLine
	strOut=strOut & "</td>" & vbNewLine
	strOut=strOut & "<td valign=top  >" & vbNewLine
	strOut=strOut & strRightContent & vbNewLine
	strOut=strOut & "</td>" & vbNewLine
	strOut=strOut & "</tr>" & vbNewLine
	strOut=strOut & "</table>" & vbNewLine
	traytable=strOut
end function

'*******************************************
'permissions functions
'*******************************************

function IsSuperUser(intUserID)
	'is intUserID a superuser?
	dim bwlOut
	if 1=myint(Data(intUserID, 0, 3, strUserData)) then
		bwlOut=true
	end if
	IsSuperUser = bwlOut
end function

'*******************************************
'form functions
'*******************************************


function Data(strIn, intTypeIn, intTypeOut, strTranslate)
	'ALLOWS us to read data in double-delimited strings of the form a|b|.|.|.-c|d|.|.|.-.-.-.
	'Gus Mueller, April 2000
	'this is the "engine" allowing me to query double-delimited strings
	'strIn is the value of the key being passed in
	'intTypeIn is the the 0-based number of the pipe-delimited field of the key being passed in
	'intTypeOut is the 0-based number of the pipe-delimited field for the data returned
	'strTranslate is the double-delimited string, where | delimits fields in a data row and - delimits rows
	'this function also has a mode where it returns the intTypeOut-th field of the strIn-th row if intTypeIn=-1
	'and this is essential for powering GenericDataPulldown
	dim arrTranslate, i, strOut, bwlDone, arrThis
	strIn=cstr(strIn)
arrTranslate=split(strTranslate, "-")
	bwlDone=false
	i=0
	do until i > ubound(arrTranslate) or bwlDone=true
		arrThis=split(arrTranslate(i), "|")
		if intTypeIn<=ubound(arrThis) and intTypeOut<=ubound(arrThis) then
			if intTypeIn=-1 then
				if cstr(strIn)=cstr(i) then
					strOut=arrThis(intTypeOut)
					bwlDone=true
				end if
			elseif lcase(arrThis(intTypeIn))=lcase(strIn) then
				strOut=arrThis(intTypeOut)
				bwlDone=true
			end if
		end if
		i=i+1
	loop
	if strOut="" then
		strOut=""
	end if
	Data=strOut
end function

function datepulldowns(strNamePre, byval dtmDefault, bwlOldDefault)
	dim intYear, intMonth, intDay, strOut
	if isnull(dtmDefault) then dtmDefault=""
	if isdate(dtmDefault) then
		intMonth=month(dtmDefault)
		intDay=day(dtmDefault)
		intYear=year(dtmDefault)
	else
		if bwlOldDefault then
			intMonth=12
			intDay=31
			intYear=99
		else
			intMonth=12
			intDay=12
			intYear=39
		end if
	end if
	if len(cstr(intYear))=4 then intYear=cint(right(intYear, 2))
	if left(cstr(intYear), 1)="0" then intYear=cint(right(intYear, 1))
	strOut=strOut & numericpulldown(1,12, intMonth, strNamePre & "month") & " / " & numericpulldown(1,31, intDay, strNamePre & "day") & " / " & numericpulldown(0, 99, intYear,  strNamePre & "year")
	datepulldowns=strOut
end function

function numericpulldown(byval intstart, byval intend, byval intdefault, byval strName)
	dim intNumber, strSel, strOut
	strOut = "<select name=" & chr(34) & strName & chr(34) & ">"
	strOut = strOut & "<option value=" & chr(34)  & chr(34) & ">none"
	for intNumber = intStart to intEnd
		strSel=""
		if cstr(intNumber)=cstr(intdefault) then strSel=" selected "
		strOut = strOut & "<option value=" & intNumber & strSel & ">" & intNumber & vbNewline
	next
	strOut = strOut & "</select>"
	numericpulldown = strOut
end function

function recentdatepulldown(strName, dtmDefault)
	dim strOut, dtmThis, t, strSel
	strOut=vbNewLine & strOut & "<select name=""" & strName & """>" & vbNewLine
	strOut=vbTab & strOut & "<option value="""" >-none-" & vbNewLine
	for t=-5 to 20
		strSel=""
		dtmThis=dateadd("d", t, now)
		if JustDate(dtmThis)=JustDate(dtmDefault) then strSel="selected"
		strOut=strOut & vbTab & "<option " & strSel & ">" & JustDate(dtmThis) & vbNewLine
	next
	strOut=strOut & "</select>" & vbNewLine
	recentdatepulldown=strOut
end function

'*******************************************
'conversion functions
'*******************************************

function myCstr(byval strIn)
	'like cstr, but turns null into ""
	if isnull(strIn) then strIn=""
	strIn=cstr(strIn)
	myCstr=strIn
end function

function myint(strIn)
	dim intOut
	if isnumeric(strIn) then
		intOut=clng(strIn)
	else
		intOut=0
	end if
	myint=intOut
end function

function CheckProcess(bwlIn)
	dim strOut
	if bwlIn=true then
		strOut="checked"
	else
		strOut=""
	end if
	CheckProcess=strOut
end function

function toBwl(strIn)
	'make an integer decidedly boullean
	dim bwlOut
	bwlOut = false
	if cstr(strIn)="1" then
		bwlOut = true
	end if
	toBwl=bwlOut
end function 

function bwltoInt(bwlIn)
	'make a boullean decidedly integer
	dim intOut
	if bwlIn=true or bwlIn=1 or bwlIn="1" then
		intOut = 1
	else
		intOut=0
	end if
	bwlToInt=intOut
end function 

'*******************************************
'etc
'*******************************************

function GetIPAddress()
	dim strOut
	strOut=request.servervariables("REMOTE_ADDR")
	GetIPAddress=strOut
end function

%>
